/*
 * Button
 *
 * Use custom button styles for actions in forms, dialogs, and more
 * with support for multiple sizes, states, and more.
 *
 * Index
 * - Button
 * - Plain
 * - Outline
 * - Disabled
 * - Sizes
 * - Badge
 */


/**
 * @prop --border-radius: Border radius of the button
 * @prop --font-size: Font size of the text button
 * @prop --margin-bottom: Bottom margin of the button
 * @prop --padding-start: Left padding  of the button
 * @prop --padding-end: Right padding of the button
 */


/* BUTTON
 -------------------- */

:host {
  --border-radius: 0.25rem;
  --font-size: var(--road-button-medium);
  --margin-bottom: 1rem;
  --padding-start: 1.5rem;
  --padding-end: 1.5rem;

  box-sizing: border-box;
  display: inline-flex;
  display: -webkit-inline-flex;
  align-items: center;
  justify-content: center;
  height: 3rem;
  padding: 0;
  margin-bottom: var(--margin-bottom);
  font-family: var(--road-font, sans-serif);
  font-size: var(--font-size);
  font-weight: 700;
  line-height: 1.375;
  color: var(--road-grey-10);
  text-decoration: none;
  white-space: nowrap;
  vertical-align: middle;
  background: transparent;
  border: 1px solid transparent;
  border-radius: var(--border-radius);
  transition: background 250ms cubic-bezier(0.4, 0, 0.2, 1) 0ms, color 250ms cubic-bezier(0.4, 0, 0.2, 1) 0ms;
}


/**
 * Fix states
 */

:host(:hover) {
  text-decoration: none;
}

:host(.focus-visible) {
  text-decoration: underline;
  outline: auto;
}


/**
 * Native button
 */

.button-native {
  position: relative;
  display: flex;
  flex-flow: row nowrap;
  flex-shrink: 0;
  align-items: center;
  justify-content: center;
  width: 100%;
  height: 100%;
  padding: 0 var(--padding-end) 0 var(--padding-start);
  margin: 0;
  font-family: inherit;
  font-size: inherit;
  font-style: inherit;
  font-weight: inherit;
  color: inherit;
  text-align: inherit;
  text-decoration: none;
  text-indent: inherit;
  text-overflow: inherit;
  text-transform: inherit;
  letter-spacing: inherit;
  white-space: inherit;
  cursor: pointer;
  background: transparent;
  border: none;
  -webkit-tap-highlight-color: rgba(0, 0, 0, 0);
}

/* PLAIN
 -------------------- */

/**
 * Default
 */

:host(.btn-default:not([disabled]).focus-visible) {
  background: var(--road-grey-80);
}

/**
 * Primary
 */

:host(.btn-primary) {
  color: var(--road-on-button-primary);
  background: var(--road-button-primary);
}

:host(.btn-primary) ::slotted(road-icon) {
  color: var(--road-on-button-primary);
}

:host(.btn-primary:not([disabled]):hover),
:host(.btn-primary:not([disabled]).focus-visible) {
  background: var(--road-button-primary-variant);
  outline: 0;
}

/**
 * Secondary
 */

:host(.btn-secondary) {
  color: var(--road-on-button-secondary);
  background: var(--road-button-secondary);
}

:host(.btn-secondary) ::slotted(road-icon) {
  color: var(--road-on-button-secondary);
}

:host(.btn-secondary:not([disabled]):hover),
:host(.btn-secondary:not([disabled]).focus-visible) {
  background: var(--road-button-secondary-variant);
}

/**
 * Destructive
 */

:host(.btn-destructive) {
  color: var(--road-on-button-destructive-primary);
  background: var(--road-button-destructive-primary);
}

:host(.btn-destructive) ::slotted(road-icon) {
  color: var(--road-on-button-destructive-primary);
}

:host(.btn-destructive:not([disabled]):hover),
:host(.btn-destructive:not([disabled]).focus-visible) {
  background: var(--road-button-destructive-primary-variant);
}

/**
 * Link
 */

:host(.btn-link) {
  font-weight: 400;
  color: var(--road-link-primary);
  text-decoration: underline;
  background: transparent;
}

:host(.btn-link:not([disabled]):hover),
:host(.btn-link:not([disabled]).focus-visible) {
  color: var(--road-primary-30);
}

/* OUTLINE
 -------------------- */

:host(.btn-outline-primary),
:host(.btn-outline-secondary),
:host(.btn-outline-default),
:host(.btn-outline-destructive) {
  background: transparent;
}

/**
 * Outline default
 */

:host(.btn-outline-default) {
  color: var(--road-on-surface-weak);
  background: var(--road-surface);
  border-color: var(--road-input-outline);
}

:host(.btn-outline-default) ::slotted(road-icon) {
  color: var(--road-on-surface-weak);
}

:host(.btn-outline-default:hover),
:host(.btn-outline-default.focus-visible) {
  background: var(--road-grey-80);
}

/**
 * Ghost
 */

:host(.btn-ghost) {
  color: var(--road-on-button-ghost);
}

:host(.btn-ghost) ::slotted(road-icon) {
  color: var(--road-on-button-ghost);
}

:host(.btn-ghost:hover),
:host(.btn-ghost.focus-visible) {
  background: var(--road-button-ghost-variant);
}

/**
 * Outline primary
 */

:host([aria-disabled].btn-outline-primary) {
  background: none;
}

:host(.btn-outline-primary) {
  color: var(--road-button-primary);
  border-color: var(--road-button-tertiary-outline);
}

:host(.btn-outline-primary) ::slotted(road-icon) {
  color: var(--road-button-primary);
}

:host(.btn-outline-primary:hover),
:host(.btn-outline-primary.focus-visible) {
  background: var(--road-button-tertiary-variant);
}

/**
 * Outline secondary
 */

:host(.btn-outline-secondary) {
  color: var(--road-button-secondary);
  border-color: var(--road-button-secondary);
}

:host(.btn-outline-secondary) ::slotted(road-icon) {
  color: var(--road-button-secondary);
}

:host(.btn-outline-secondary:hover),
:host(.btn-outline-secondary.focus-visible) {
  background: var(--road-button-tertiary-variant);
}

/**
 * Outline destructive
 */

:host(.btn-outline-destructive) {
  color: var(--road-on-button-destructive-secondary);
  border-color: var(--road-button-destructive-outline);
}

:host(.btn-outline-destructive) ::slotted(road-icon) {
  color: var(--road-on-button-destructive-secondary);
}

:host(.btn-outline-destructive:hover),
:host(.btn-outline-destructive.focus-visible) {
  background: var(--road-button-destructive-secondary-variant);
}

/* DISABLED
 -------------------- */

:host([aria-disabled]) {
  color: var(--road-on-surface-disabled);
  pointer-events: none;
  cursor: not-allowed;
  background-color: var(--road-surface-disabled);
  border-color: 1px solid var(--road-surface-disabled);
}

:host([aria-disabled]) ::slotted(road-icon){
  color: var(--road-on-surface-disabled);
}

.button-native:disabled {
  cursor: not-allowed;
}

/* SIZES
 -------------------- */

::slotted([slot="start"]) {
  margin-right: 0.5rem;
}

::slotted([slot="end"]) {
  margin-left: 0.5rem;
}

/**
 * Extra Large
 */

:host(.btn-xl) {
  height: 3.5rem;
}

:host(.btn-xl) ::slotted(road-icon) {
  width: 2rem;
  height: 2rem;
}

:host(.btn-icon.btn-xl) {
  width: 56px;
}


/**
 * Large
 */

:host(.btn-lg) {
  height: 3rem;
}

:host(.btn-lg) ::slotted(road-icon) {
  width: 2rem;
  height: 2rem;
}


:host(.btn-icon.btn-lg) {
  width: 48px;
}

/**
 * Medium
 */

:host(.btn-md) {
  --font-size: var(--road-font-size-14);

  height: 2.5rem;
}

:host(.btn-md) ::slotted(road-icon) {
  width: 1.5rem;
  height: 1.5rem;
}

:host(.btn-icon.btn-md) {
  width: 40px;
}

/**
 * Small
 */

:host(.btn-sm) {
  --font-size: var(--road-font-size-14);

  height: 2rem;
}

:host(.btn-sm) ::slotted(road-icon) {
  width: 1.25rem;
  height: 1.25rem;
}

:host(.btn-icon.btn-sm) {
  width: 32px;
}

/**
 * Button block
 */

:host(.btn-block) {
  width: 100%;
}

:host(.btn-icon) .button-native{
  padding: 0;
}


/* BADGE
 -------------------- */

::slotted(road-badge) {
  position: absolute;
  top: 4px;
  left: calc(50% + 0.375rem);
  box-sizing: border-box;
  height: auto;
}
